/****************************************************************************\
 *           Copyright (C) 2011, 2012 Texas Instruments Incorporated.             *
 *                           All Rights Reserved                            *
 *                                                                          *
 * GENERAL DISCLAIMER                                                       *
 * ------------------                                                       *
 * All software and related documentation is provided "AS IS" and without   *
 * warranty or support of any kind and Texas Instruments expressly disclaims*
 * all other warranties, express or implied, including, but not limited to, *
 * the implied warranties of merchantability and fitness for a particular   *
 * purpose.  Under no circumstances shall Texas Instruments be liable for   *
 * any incidental, special or consequential damages that result from the    *
 * use or inability to use the software or related documentation, even if   *
 * Texas Instruments has been advised of the liability.                     *
 ****************************************************************************
 * Created by :                                                             *
 *            Brighton Feng                                                 *
 *            Texas Instruments                                             * 
 *            August 12, 2011                                                 *
Updated on June 18, 2012 for TCI6614 by Brighton
\***************************************************************************/
#ifndef _AIF_DEBUG_H
#define _AIF_DEBUG_H
#include <tistdtypes.h>
#include <cslr_aif2.h>


typedef struct  {
    volatile Uint32 SD_RX_STS;
    volatile Uint32 SD_TX_STS;
} Aif2Sd_lkStsRegs;

typedef struct  {
    volatile Uint32 RM_LK_CFG0;
    volatile Uint32 RM_LK_CFG1;
    volatile Uint32 RM_LK_STS0;
    volatile Uint32 RM_LK_STS1;
    volatile Uint32 RM_LK_STS2;
    volatile Uint32 RM_LK_STS3;
    volatile Uint32 RM_LK_STS4;
} Aif2G_rm_lkStsRegs;

typedef struct  {
    volatile Uint32 RT_LK_DPTH;
    volatile Uint32 RT_HDR_ERR;
    volatile Uint32 RT_LK_STAT;
} Aif2G_rt_lkStsRegs;

typedef struct  {
    volatile Uint32 EE_LK_IRS_A;
    volatile Uint32 EE_LK_IRS_B;
} Aif2Ee_lkIrsRegs;

/*copy of AIF2 error status registers*/
typedef struct  {
    volatile Uint32 EE_DB_IRS;
    volatile Uint32 EE_AD_IRS;
    volatile Uint32 EE_CD_IRS;
    volatile Uint32 EE_SD_IRS;
    volatile Uint32 EE_VC_IRS;
    volatile Uint32 EE_AIF2_RUN_STS;
    volatile Uint32 EE_AIF2_RUN_CTL;
    volatile Uint32 EE_ERR_ALRM_ORGN;
    volatile Uint32 SD_PLL_B8_STS;
    volatile Uint32 SD_PLL_B4_STS;
    volatile Uint32 EE_AT_IRS;
    volatile Uint32 EE_PD_COMMON_IRS;
    volatile Uint32 EE_PE_COMMON_IRS;
    volatile Uint32 AT_CAPTRADT;
    volatile Uint32 AT_PHYT_CLKCNT_VALUE;
    volatile Uint32 AT_PHYT_FRM_VALUE_LSBS;
    volatile Uint32 AT_PHYT_FRM_VALUE_MSBS;
    volatile Uint32 AT_RADT_VALUE_LSBS;
    volatile Uint32 AT_RADT_VALUE_MID;
    volatile Uint32 AT_RADT_VALUE_MSBS;
    volatile Uint32 AT_ULRADT_VALUE_LSBS;
    volatile Uint32 AT_ULRADT_VALUE_MID;
    volatile Uint32 AT_ULRADT_VALUE_MSBS;
    volatile Uint32 AT_DLRADT_VALUE_LSBS;
    volatile Uint32 AT_DLRADT_VALUE_MID;
    volatile Uint32 AT_DLRADT_VALUE_MSBS;
    volatile Uint32 AT_RADT_WCDMA_VALUE;
    volatile Uint32 AT_ULRADT_WCDMA_VALUE;
    volatile Uint32 AT_DLRADT_WCDMA_VALUE;
    volatile Uint32 PD_GLOBAL_EN_STS;
    volatile Uint32 AD_ISCH_EOP_CNT;
    volatile Uint32 DB_EDB_EOP_CNT;
    Aif2Sd_lkStsRegs SD_LK[6];
    Aif2Ee_lkIrsRegs EE_LK[6];
    CSL_Aif2Pi_dataRegs PI_DATA[6];
    volatile Uint32 TM_LK_STAT[6];
    Aif2G_rm_lkStsRegs G_RM_LKS[6];
    Aif2G_rt_lkStsRegs G_RT_LKS[6];
    volatile Uint32 PD_CHAN_STS[4];
    volatile Uint32 PD_PKT_STS[4];
    volatile Uint32 PE_CHAN_STS[4];
    volatile Uint32 PE_PKT_STS[4];
} Aif2ErrorStatusRegs;

extern CSL_Aif2Regs aif2RegsLog;

/*copy AIF2 error status registers to a local data structure for later check*/
extern void copyAif2ErrStsRegs();
extern void copyAif2Regs();
extern void print_error_status_interrupt();
extern void print_AIF_status();
extern void check_IDB_channel(Uint32 uiChannel);

#endif
