/****************************************************************************\
 *           Copyright (C) 2011, 2012 Texas Instruments Incorporated.             *
 *                           All Rights Reserved                            *
 *                                                                          *
 * GENERAL DISCLAIMER                                                       *
 * ------------------                                                       *
 * All software and related documentation is provided "AS IS" and without   *
 * warranty or support of any kind and Texas Instruments expressly disclaims*
 * all other warranties, express or implied, including, but not limited to, *
 * the implied warranties of merchantability and fitness for a particular   *
 * purpose.  Under no circumstances shall Texas Instruments be liable for   *
 * any incidental, special or consequential damages that result from the    *
 * use or inability to use the software or related documentation, even if   *
 * Texas Instruments has been advised of the liability.                     *
 ****************************************************************************
 * Created by :                                                             *
 *            Brighton Feng                                                 *
 *            Texas Instruments                                             * 
 *            August 10, 2011                                                 *
Updated on June 18, 2012 for TCI6614 by Brighton
\***************************************************************************/
#ifndef AIF_INTC_SETUP_H
#define AIF_INTC_SETUP_H 

typedef enum
{
	EE_LK_STS_A0 = 0 ,
	EE_LK_STS_B0 = 1 ,
	EE_LK_STS_A1 = 2 ,
	EE_LK_STS_B1 = 3 ,
	EE_LK_STS_A2 = 4 ,
	EE_LK_STS_B2 = 5 ,
	EE_LK_STS_A3 = 6 ,
	EE_LK_STS_B3 = 7 ,
	EE_LK_STS_A4 = 8 ,
	EE_LK_STS_B4 = 9 ,
	EE_LK_STS_A5 = 10,
	EE_LK_STS_B5 = 11,
	EE_AT_STS    = 12,
	EE_SD_STS    = 13,
	EE_DB_STS    = 14,
	EE_AD_STS    = 15,
	EE_CD_STS    = 16,
	EE_VC_STS    = 17,
	NUM_ERR_STS_REGS
} AIF_Error_Status_Regs_Index;

typedef struct  {
    volatile Uint32 IRS;
    volatile Uint32 IRS_SET;
    volatile Uint32 IRS_CLR;
    volatile Uint32 EN_EV0;
    volatile Uint32 EN_SET_EV0;
    volatile Uint32 EN_CLR_EV0;
    volatile Uint32 EN_EV1;
    volatile Uint32 EN_SET_EV1;
    volatile Uint32 EN_CLR_EV1;
    volatile Uint32 EN_STS_EV0;
    volatile Uint32 EN_STS_EV1;
} Aif_INT_STS;

typedef struct  {
    volatile Uint32 IRS;
    volatile Uint32 IRS_SET;
    volatile Uint32 IRS_CLR;
    volatile Uint32 EN_EV;
    volatile Uint32 EN_SET_EV;
    volatile Uint32 EN_CLR_EV;
    volatile Uint32 EN_STS_EV;
} Aif_CD_INT_STS;

typedef struct  {
	AIF_Error_Status_Regs_Index IRS_index;
	Uint32 	IRS_value;
	Uint32 	frame_cnt;
	Uint32 	AT_RADT_VALUE_LSBS;
} Aif_Error_Status_Log;

extern volatile Bool bTerminating; 	//Is AIF2 in the progress of terminating?
extern Uint32 uiCtlPktCount;
extern Uint32 uiUlSymbolSlotCount;
extern Uint32 uiSlotCount;
extern Uint32 uiFrameCount;

extern Aif_Error_Status_Log err_sts_log[];
extern Uint32 err_sts_log_cnt;

extern void AIF_Interrupts_Init(void);
extern void Enable_AIF_error_status_interrupt();
extern void clear_AIF_error_status();
extern void Clear_AIF2_INTC();
extern void Counter_Init();

#endif /* AIF_INTC_SETUP_H */

