/******************************************************************************

  Copyright (C), 2001-2012, Texas Instrument.

 ******************************************************************************
  File Name     : Robust_INTC.h
  Version       : Initial Draft
  Author        : Brighton Feng
  Created       : 2012/10/7
  Last Modified :
  Description   : Robust_INTC.c header file
                  This file setup interrupt controller, and includes:
                1, ISR for memory protection and EDC/ECC.
                2, function to manually tigger two interrupts to show the interrup drop monitor
  Function List :
  History       :
  1.Date        : 2012/10/7
    Author      : Brighton Feng
    Modification: Created file

******************************************************************************/

/*----------------------------------------------*
 * external variables                           *
 *----------------------------------------------*/

/*----------------------------------------------*
 * external routine prototypes                  *
 *----------------------------------------------*/

/*----------------------------------------------*
 * internal routine prototypes                  *
 *----------------------------------------------*/

/*----------------------------------------------*
 * project-wide global variables                *
 *----------------------------------------------*/

/*----------------------------------------------*
 * module-wide global variables                 *
 *----------------------------------------------*/

/*----------------------------------------------*
 * constants                                    *
 *----------------------------------------------*/

/*----------------------------------------------*
 * macros                                       *
 *----------------------------------------------*/

/*----------------------------------------------*
 * routines' implementations                    *
 *----------------------------------------------*/

#ifndef __ROBUST_INTC_H__
#define __ROBUST_INTC_H__


#ifdef __cplusplus
#if __cplusplus
extern "C"{
#endif
#endif /* __cplusplus */

extern void Robust_Interrupts_Init(void);
extern void INT_drop_test();
extern interrupt void Timer_ISR(void);
extern interrupt void LL2_EDC_ISR();
extern interrupt void SL2_EDC_ISR();

#ifdef __cplusplus
#if __cplusplus
}
#endif
#endif /* __cplusplus */


#endif /* __ROBUST_INTC_H__ */
